with Ada.Text_IO;
procedure Gen_Stub is
   
   use Ada.Text_IO;
   
   Spec, Impl, Def : File_Type;

   procedure Add_Entry (Name : String)
   is
   begin
       Put_Line (Spec, 
         "function " & Name & " return Integer;"
         & ASCII.LF & "pragma Export(C, " & Name & ", """ & Name & """);");
       Put_Line (Impl, 
         "function " & Name & " return Integer"
         & ASCII.LF & "is begin return -1; end;");
       Put_Line (Def, ASCII.HT & Name);
   end;

begin
   Create (Spec, Out_File, "oci-stub.ads");
   Create (Impl, Out_File, "oci-stub.adb");
   Create (Def, Out_File, "oci.def");
   Put_Line (Spec, "package OCI.Stub is");
   Put_Line (Impl, "package body OCI.Stub is");
   Put_Line (Def, "EXPORTS");

   Add_Entry ("OCIEnvCreate");
   Add_Entry ("OCIErrorGet");
   Add_Entry ("OCILogon");
   Add_Entry ("OCILogoff");
   Add_Entry ("OCIInitialize");
   Add_Entry ("OCIEnvInit");
   Add_Entry ("OCIHandleAlloc");
   Add_Entry ("OCIHandleFree");
   Add_Entry ("OCIStmtPrepare");
   Add_Entry ("OCIStmtExecute");
   Add_Entry ("OCIParamGet");
   Add_Entry ("OCIAttrGet");
   Add_Entry ("OCIAttrSet");
   Add_Entry ("OCIStmtFetch");
   Add_Entry ("OCIBindByName");
   Add_Entry ("OCIBindByPos");
   Add_Entry ("OCIDefineByPos");
   Add_Entry ("OCIDateToText");
   Add_Entry ("OCIDateSysDate");
   Add_Entry ("OCIStringResize");
   Add_Entry ("OCIStringAssignText");
   Add_Entry ("OCIStringPtr");
   Add_Entry ("OCIStringSize");
   Add_Entry ("OCIStringAllocSize");
   Add_Entry ("OCIDescriptorAlloc");
   Add_Entry ("OCIDescriptorFree");
   Add_Entry ("OCIServerVersion");
   Add_Entry ("OCITransCommit");
   Add_Entry ("OCITransRollback");
   Add_Entry ("OCINumberAbs");
   Add_Entry ("OCINumberArcCos");
   Add_Entry ("OCINumberArcSin");
   Add_Entry ("OCINumberArcTan");
   Add_Entry ("OCINumberAssign");
   Add_Entry ("OCINumberCeil");
   Add_Entry ("OCINumberCos");
   Add_Entry ("OCINumberExp");
   Add_Entry ("OCINumberFloor");
   Add_Entry ("OCINumberHypCos");
   Add_Entry ("OCINumberHypSin");
   Add_Entry ("OCINumberHypTan");
   Add_Entry ("OCINumberLn");
   Add_Entry ("OCINumberNeg");
   Add_Entry ("OCINumberSin");
   Add_Entry ("OCINumberSqrt");
   Add_Entry ("OCINumberTan");
   Add_Entry ("OCINumberArcTan2");
   Add_Entry ("OCINumberAdd");
   Add_Entry ("OCINumberDiv");
   Add_Entry ("OCINumberLog");
   Add_Entry ("OCINumberMod");
   Add_Entry ("OCINumberMul");
   Add_Entry ("OCINumberPower");
   Add_Entry ("OCINumberSub");
   Add_Entry ("OCINumberToReal");
   Add_Entry ("OCINumberFromReal");
   Add_Entry ("OCINumberToText");
   Add_Entry ("OCINumberFromText");
   Add_Entry ("OCILobAppend");
   Add_Entry ("OCILobAssign");
   Add_Entry ("OCILobCharSetForm");
   Add_Entry ("OCILobCharSetId");
   Add_Entry ("OCILobCopy");
   Add_Entry ("OCILobCreateTemporary");
   Add_Entry ("OCILobClose");
   Add_Entry ("OCILobDisableBuffering");
   Add_Entry ("OCILobEnableBuffering");
   Add_Entry ("OCILobErase");
   Add_Entry ("OCILobFileClose");
   Add_Entry ("OCILobFileCloseAll");
   Add_Entry ("OCILobFileExists");
   Add_Entry ("OCILobFileGetName");
   Add_Entry ("OCILobFileIsOpen");
   Add_Entry ("OCILobFileOpen");
   Add_Entry ("OCILobFileSetName");
   Add_Entry ("OCILobFlushBuffer");
   Add_Entry ("OCILobFreeTemporary");
   Add_Entry ("OCILobGetChunkSize");
   Add_Entry ("OCILobGetLength");
   Add_Entry ("OCILobIsEqual");
   Add_Entry ("OCILobIsOpen");
   Add_Entry ("OCILobIsTemporary");
   Add_Entry ("OCILobLoadFromFile");
   Add_Entry ("OCILobLocatorAssign");
   Add_Entry ("OCILobLocatorIsInit");
   Add_Entry ("OCILobOpen");
   Add_Entry ("OCILobRead");
   Add_Entry ("OCILobTrim");
   Add_Entry ("OCILobWrite");
   Add_Entry ("OCILobWriteAppend");
   Add_Entry ("OCIStmtGetBindInfo");
   Add_Entry ("OCIDescribeAny");
   Add_Entry ("OCIBindDynamic");
   Add_Entry ("OCIDefineDynamic");
   Add_Entry ("ociepgoe");
   Add_Entry ("OCITerminate");
   Add_Entry ("OCIUserCallbackRegister");
   Add_Entry ("OCIServerAttach");
   Add_Entry ("OCIServerDetach");
   Add_Entry ("OCISessionBegin");
   Add_Entry ("OCISessionEnd");
   Add_Entry ("OCIBreak");
   Add_Entry ("OCIReset");
   Add_Entry ("OCISubscriptionRegister");
   Add_Entry ("OCISubscriptionUnRegister");
   Add_Entry ("OCISubscriptionDisable");
   Add_Entry ("OCISubscriptionEnable");
   Add_Entry ("OCISubscriptionPost");

   Put_Line (Spec, "end OCI.Stub;");
   Put_Line (Impl, "end OCI.Stub;");
end;