------------------------------------------------------------------------------
--  Ada95 Interface to Oracle RDBMS                                         --
--  Copyright (C) 2000-2002 Dmitriy Anisimkov.                              --
--  License text and authors contact information are in the file oci.ads    --
------------------------------------------------------------------------------

--  $Id$

with
   OCI.Lib,
   OCI.Reference_Finalization;

package OCI.Environments is

   use OCI.Lib;
   package RF renames Reference_Finalization;
   
   type Thread_Environment is new RF.Controlled_Reference with record
      Handle : OCIEnv := OCIEnv (Empty_Handle);
   end record;
   
--   procedure Create (Environment : in out Thread_Environment);
   function Create return Thread_Environment;
   
   Init_Environment : constant Thread_Environment;

   procedure Set_Create_Mode_Flag (Flag : UB4);
   
   protected Counter is
      procedure Add (It : Integer);
      function Value return Integer;
   private
      Val : Integer := 0;
   end Counter;

   Last_Size : Integer := 0;

private

   procedure Destroy   (Object : in out Thread_Environment);

   Init_Environment : constant Thread_Environment := 
       (RF.Controlled_Reference with 
            Handle => OCIEnv(Empty_Handle));

   ENVIRONMENT_CREATION_ERROR : exception;

end OCI.Environments;