------------------------------------------------------------------------------
--  Thin Ada95 binding to OCI (Oracle Call Interface)                    --
--  Copyright (C) 2000-2002 Dmitriy Anisimkov.                              --
--  License agreement and authors contact information are in file oci.ads   --
------------------------------------------------------------------------------
--  Oracle Call Interfase is Trademark of Oracle Corporation              --
------------------------------------------------------------------------------

--  $Id$

with System, Ada.Finalization;

package OCI.Reference_Finalization is

   package AF renames Ada.Finalization;
  
   type Controlled_Reference is abstract new AF.Controlled with private;
   
   procedure Destroy (Object : in out Controlled_Reference) is abstract;
   
private

   type Ref_Count is mod System.Max_Binary_Modulus;
   
   protected type Counter is
      procedure Dec (Zero : out Boolean);
      procedure Inc;
   private
      Data : Ref_Count := 0;
   end Counter;
  
   type Access_Count is access all Counter;
   
   type Controlled_Reference is abstract new AF.Controlled with record
      Refer : Access_Count := null;
   end record;
   
   procedure Initialize (Object : in out Controlled_Reference);
   procedure Adjust    (Object : in out Controlled_Reference);
   procedure Finalize  (Object : in out Controlled_Reference);

end OCI.Reference_Finalization;