------------------------------------------------------------------------------
--  Thin Ada95 binding to OCI (Oracle Call Interface)                    --
--  Copyright (C) 2000-2002 Dmitriy Anisimkov.                              --
--  License agreement and authors contact information are in file oci.ads   --
------------------------------------------------------------------------------

--  $Id$

with OCI.Lib;
with OCI.Thread;
with Interfaces.C;
package body OCI.Thick.Date is

   use Lib;

   -------------
   -- SysDate --
   -------------

   function SysDate return OCIDate is
      Result : aliased OCIDate;
      Rc :  Sword := OCIDateSysDate (Err => Thread.Error,
         Date => Result'access);
   begin
      Check_Error (Rc);
      return Result;
   end SysDate;

   ---------------
   -- To_String --
   ---------------

   function To_String (From : OCIDate; Format : String) return String
   is
      use Interfaces.C;
      Buff : aliased Text := (0 .. Format'Length + 64 => C.nul);
      Len : aliased Ub4 := Buff'Length - 1; 
      Rc : Sword := OCIDateToText (
         Err => Thread.Error,
         Date => From,
         Fmt => C.To_C (Format),
         Fmt_Length => Format'Length,
         Lang_Name => 0,
         Lang_Length => 0,
         Buf_Size => Len'access,
         Buf => CStr.To_Chars_Ptr(Buff'Unchecked_Access));
   begin
      Check_Error (Rc);
      return C.To_Ada(Buff,False)(1..Integer(Len));
   end To_String;

end OCI.Thick.Date;
